## python-linstor-1.7.1.tar.gz

=== Makefile ===
GIT = git
INSTALLFILES=.installfiles
PYTHON ?= python3
override GITHEAD := $(shell test -e .git && $(GIT) rev-parse HEAD)

U := $(shell $(PYTHON) ./setup.py versionup2date >/dev/null 2>&1; echo $$?;)
TESTS = $(wildcard unit-tests/*_test.py)

all:
	$(PYTHON) setup.py build

install: gensrc linstor/consts_githash.py
	$(PYTHON) setup.py install --record $(INSTALLFILES)

uninstall:
	test -f $(INSTALLFILES) && cat $(INSTALLFILES) | xargs rm -rf || true
	rm -f $(INSTALLFILES)

ifneq ($(U),0)
up2date:
	$(error "Update your Version strings/Changelogs")
else
up2date: linstor/consts_githash.py
	$(info "Version strings/Changelogs up to date")
endif

.PHONY: linstor/drbdsetup_options.py
linstor/drbdsetup_options.py:
	linstor-common/gendrbdoptions.py python $@

release: up2date clean
	$(PYTHON) setup.py sdist
	@echo && echo "Did you run distclean?"
	@echo && echo "Did you generate and commit the latest drbdsetup options?"

debrelease:
	echo 'recursive-include debian *' >> MANIFEST.in
	dh_clean || true
	make release
	git checkout MANIFEST.in

.PHONY: gensrc
gensrc:
	make -C linstor-common cleanpython
	make -C linstor-common python

# no gensrc here, that is in debian/rules
deb: up2date
	[ -d ./debian ] || (echo "Your checkout/tarball does not contain a debian directory" && false)
	debuild -i -us -uc -b

# it is up to you (or the buildenv) to provide a distri specific setup.cfg
rpm: gensrc up2date
	$(PYTHON) setup.py bdist_rpm

.PHONY: linstor/consts_githash.py
ifdef GITHEAD
override GITDIFF := $(shell $(GIT) diff --name-only HEAD 2>/dev/null | \
			grep -vxF "MANIFEST.in" | \
			tr -s '\t\n' '  ' | \
			sed -e 's/^/ /;s/ *$$//')
linstor/consts_githash.py:
	@echo "GITHASH = 'GIT-hash: $(GITHEAD)$(GITDIFF)'" > $@
else
linstor/consts_githash.py:
	@echo >&2 "Need a git checkout to regenerate $@"; test -s $@
endif

md5sums:
	CURDATE=$$(date +%s); for i in $$(${GIT} ls-files | sort); do md5sum $$i >> md5sums.$${CURDATE}; done

clean:
	$(PYTHON) setup.py clean

distclean: clean
	git clean -d -f || true

check:
	# currently none
	# $(PYTHON) $(TESTS)

.PHONY: doc upload-doc
doc: gensrc
	make -C doc html

upload-doc: doc
	tmpd=$$(mktemp -p $$PWD -d) && \
	cp -r ./doc/_build/html/* $$tmpd && cd $$tmpd && touch .nojekyll && \
	git init && git add . && git commit -m "gh-pages" && \
	git push -f git@github.com:LINBIT/linstor-api-py.git master:gh-pages && \
	rm -rf $$tmpd

=== linstor-common/Makefile ===
PYTHON ?= python3
COMMONDRBDOPTS=drbdoptions.json
COMMONPROPERTIES=properties.json


PYCONSTS=../linstor/sharedconsts.py
PYPROPS=../linstor/properties.py

JAVABASEOUT=../server/generated-src
JAVAOUT=$(JAVABASEOUT)/com/linbit
JAVAAPIOUT=$(JAVAOUT)/linstor/api
JAVACONSTS=$(JAVAAPIOUT)/ApiConsts.java
JAVAPROPOUT=$(JAVAAPIOUT)/prop
JAVAPROPERTYRULES=$(JAVAPROPOUT)/GeneratedPropertyRules.java

GOCONSTS=../apiconsts.go

# make java the default one
all: java

%.json:
	;

$(PYCONSTS): genconsts.py consts.json
	$(PYTHON) ./genconsts.py python ../linstor

$(JAVAPROPOUT):
	mkdir -p $@

$(JAVAPROPERTYRULES): genproperties.py $(COMMONPROPERTIES) $(COMMONDRBDOPTS) $(JAVAPROPOUT)
	$(PYTHON) ./genproperties.py java $(COMMONPROPERTIES) $(COMMONDRBDOPTS) > $@

$(PYPROPS): genproperties.py $(COMMONPROPERTIES) $(COMMONDRBDOPTS)
	$(PYTHON) ./genproperties.py python $(COMMONPROPERTIES) $(COMMONDRBDOPTS) > $@

$(COMMONDRBDOPTS): gendrbdoptions.py
	$(PYTHON) ./gendrbdoptions.py $(COMMONDRBDOPTS)

$(JAVAAPIOUT):
	mkdir -p $@

$(JAVACONSTS): genconsts.py consts.json $(JAVAAPIOUT)
	$(PYTHON) ./genconsts.py java $(JAVAAPIOUT)

$(GOCONSTS): genconsts.py consts.json
	$(PYTHON) ./genconsts.py golang ../

python: $(PYCONSTS) $(PYPROPS)

java: $(JAVACONSTS) $(COMMONDRBDOPTS) $(JAVAPROPERTYRULES)

golang: $(GOCONSTS)

cleancommon:
	rm -f $(COMMONDRBDOPTS)

cleanpython: cleancommon
	rm -f $(PYCONSTS) $(PYPROPS)

cleanjava: cleancommon
	rm -f $(JAVACONSTS) $(JAVAPROPERTYRULES)
	rm -Rf $(JAVAAPIOUT) $(JAVAPROPOUT)

clean: cleanpython cleanjava

=== debian/changelog ===
python-linstor (1.7.1-1) experimental; urgency=medium

  [ Rene Peinthor ]
  * doc: fix doc generation
  * linstor-common: use updated drbd options data
  * resource-hapi: don't set a redundancy default

  [ Gabor Hernadi ]
  * Exos: Made health_reasons optional

 -- Rene Peinthor <rene.peinthor@linbit.com>  Tue, 18 May 2021 10:45:11 +0000

python-linstor (1.7.0-1) experimental; urgency=medium

  [ Rene Peinthor ]
  * linstorapi: fix expected return type
  * setup.py: update classifiers
  * use latest linstor-common
  * gitlab-ci: trigger linstor-tests on jenkins push
  * setup.py: make checkuptodate step unicode aware

  [ Moritz "WanzenBug" Wanzenböck ]
  * gitmodules: unset update strategy
  * Add option to re-use a client object in high-level API
  * Relicense as LGPLv3
  * py2: fix encoding compat
  * add missing existing_client argument for ResourceGroup
  * use storage_pool_list in hihg-level resource group

  [ Gabor Hernadi ]
  * sp-create: added external_locking
  * linstor-pools: add exos support
  * RG: add diskless-storpool-list filter
  * RG,create: only add aditional_count if necessary

 -- Rene Peinthor <rene.peinthor@linbit.com>  Tue, 27 Apr 2021 11:33:44 +0000

python-linstor (1.6.0-1) experimental; urgency=medium

  [ Rene Peinthor ]
  * responses-node: add flags property
  * linstor-common: update
  * linstorapi: add node_restore

  [ Gabor Hernadi ]
  * linstorapi: add diskless placement and relative count to auto-placer

 -- Rene Peinthor <rene.peinthor@linbit.com>  Fri, 18 Dec 2020 08:51:14 +0000

python-linstor (1.4.2-1) experimental; urgency=medium

  * linstorapi: retry request sending on socket.error
  * linstorapi: query API for space-reporting
  * linstorapi: better report non JSON errors

 -- Rene Peinthor <rene.peinthor@linbit.com>  Wed, 25 Nov 2020 11:58:17 +0000

python-linstor (1.4.1-1) experimental; urgency=medium

  * size_calc: Add unit_to_str method
  * update to latest linstor-common

 -- Rene Peinthor <rene.peinthor@linbit.com>  Mon, 09 Nov 2020 08:20:59 +0000

python-linstor (1.4.0-1) experimental; urgency=medium

  * linstorapi: add error_report_delete method
  * gitlab-ci: deploy to our nexus repo
  * node-create: make node type and com type case insensitive

 -- Rene Peinthor <rene.peinthor@linbit.com>  Wed, 23 Sep 2020 09:35:00 +0000

python-linstor (1.3.0-1) experimental; urgency=medium

  * fix cyclic imports
  * setup.py: run make gensrc before doing standard python build
  * add snapshot_shipping_list method
  * linstor-common: add disable-http-metrics property
  * linstor-common: StorDriver/ZfscreateOptions, DrbdOptions/auto-diskful

 -- Rene Peinthor <rene.peinthor@linbit.com>  Mon, 17 Aug 2020 12:17:55 +0000

python-linstor (1.2.0-1) experimental; urgency=medium

  * add sos-report support
  * responses-errorreport: add new fields
  * use latest linstor-common
  * linstorapi: fix resource_dfn_props_list filtering
  * responses: survive apicalls without a message
  * linstorapi: fix curl mode on requests
  * sos-report: better query arg concat
  * linstorapi: remove last traces of ProtoMessageResponse
  * doc: fix docstrings and sphinx docs
  * linstorapi: support modify resource group on resource definition
  * use single StorDriver/StorPoolName property for newer API
  * linstor-common: update, use property infos
  * linstorapi: add resource activate/deactivate
  * linstorapi: add snapshot_ship method
  * linstorapi/rsc-create: add inactive flag
  * responses: add Snapshot class and Resource.create_datetime()
  * linstor-common: use rebased master/snapshot-shipping
  * linstor-common: use input file modification date for copyright range

 -- Rene Peinthor <rene.peinthor@linbit.com>  Mon, 03 Aug 2020 10:16:09 +0000

python-linstor (1.1.2-1) experimental; urgency=medium

  * linstorapi: python2.7 fix str type checks

 -- Rene Peinthor <rene.peinthor@linbit.com>  Thu, 28 May 2020 14:17:18 +0000

python-linstor (1.1.1-1) experimental; urgency=medium

  * api: support storage-pool list argument
  * gitlab-ci: use xmlrunner and create junit reports

 -- Rene Peinthor <rene.peinthor@linbit.com>  Wed, 20 May 2020 10:56:37 +0000

python-linstor (1.1.0-1) experimental; urgency=medium

  * linstor-api: use new /view/snapshots
  * add gitlab ci
  * property filtering support
  * responses-node: add properties property
  * linstor-common: update to master

 -- Rene Peinthor <rene.peinthor@linbit.com>  Thu, 07 May 2020 08:09:54 +0000

python-linstor (1.0.15-1) experimental; urgency=medium

  * use newer drbdsetup.xml
  * use new device layer kind enum type
  * fix unset auto select filters on modify
  * rsc-grp-spawn: support external name

 -- Rene Peinthor <rene.peinthor@linbit.com>  Wed, 08 Apr 2020 13:57:16 +0000

python-linstor (1.0.14-1) experimental; urgency=medium

  * linstorapi: make api_version_smaller public
  * responses: Add DrbdResource layer data object and drbdconnections
  * resource: report first error not first message
  * add support for openflex on node and storage pool
  * node-create: add property dict as param

 -- Rene Peinthor <rene.peinthor@linbit.com>  Wed, 11 Mar 2020 13:21:58 +0000

python-linstor (1.0.13-1) experimental; urgency=medium

  * responses: add more storagepool docstrings
  * keyvaluestore: fix incorrect api access
  * use new const enum type
  * resource: allow to only spawn definitions

 -- Rene Peinthor <rene.peinthor@linbit.com>  Tue, 03 Mar 2020 14:35:23 +0000

python-linstor (1.0.11-1) experimental; urgency=medium

  [ Roland Kammerer ]
  * high-level API: expose query_max_volume_size in RG

  [ Rene Peinthor ]
  * decode: utf-8 has to be specified for py2
  * support gross-size in volume groups

 -- Rene Peinthor <peinthor@gmail.com>  Mon, 27 Jan 2020 13:18:33 +0000

python-linstor (1.0.10-1) experimental; urgency=medium

  * fix json parsing in python3 < 3.6

 -- Rene Peinthor <peinthor@gmail.com>  Wed, 15 Jan 2020 07:27:15 +0000

python-linstor (1.0.9-1) experimental; urgency=medium



=== debian/control ===
Source: python-linstor
Maintainer: LINBIT HA Solutions GmbH <drbd-user@lists.linbit.com>
Uploaders: Roland Kammerer <roland.kammerer@linbit.com>
Section: python
Priority: optional
Build-Depends: bash-completion,
               debhelper (>= 9),
               dh-python,
               docbook-xsl,
               help2man,
               python3-all (>= 3.5),
               python3-setuptools,
               xsltproc
Standards-Version: 3.9.6

Package: python-linstor
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends}
Description: Linstor python api library
 This library provides functions to access the Linstor controller
 e.g.: add nodes, resources and query object status
 .

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = python-linstor

%:
	dh $@ --with python3 --buildsystem=pybuild $(WITH_BASHCOMPL)

override_dh_auto_build:
	make gensrc
	dh_auto_build

override_dh_install:
	dh_install --fail-missing
